=== debian/changelog ===
di (4.34-2build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:19:26 +0000

di (4.34-2) unstable; urgency=low

  * New upstream release (Closes: #711816)
  * Makefile now uses mkdir -p this should fix ftbfs (Closes: #713234)

 -- Michael Ablassmeier <abi@debian.org>  Sat, 22 Jun 2013 14:37:01 +0200
