=== debian/control ===
Source: di
Section: utils
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael Ablassmeier <abi@debian.org>
Build-Depends: debhelper (>= 7.0.50~), gettext
Standards-Version: 3.9.1
Homepage: http://www.gentoo.com/di/

Package: di
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: advanced df like disk information utility
 `di' is a disk information utility, displaying everything
 (and more) that your `df' command does. It features the
 ability to display your disk usage in whatever format you
 desire/prefer/are used to. It is designed to be portable
 across many platforms.
