## di 4.46

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,6 @@
 #  di makefile - top level
 #
 #  Copyright 2001-2011 Brad Lanam Walnut Creek CA, USA
-#
-#  $Id: Makefile,v 1.13 2012-11-07 16:10:34-08 bll Exp $
 #
 
 SHELL = /bin/sh
@@ -69,12 +67,17 @@
 .PHONY: all
 all:
 	$(MAKE) checkbuild
-	cd C >/dev/null && $(MAKE) -e all
+	cd C >/dev/null && $(MAKE) CC=$(CC) -e all
 
 .PHONY: all-c
 all-c:
 	$(MAKE) checkbuild
-	cd C >/dev/null && $(MAKE) -e all
+	cd C >/dev/null && $(MAKE) CC=$(CC) -e all
+
+.PHONY: tcl-sh
+tcl-sh:
+	$(MAKE) checkbuild
+	cd C >/dev/null && $(MAKE) CC=$(CC) -e tcl-sh
 
 .PHONY: all-d
 all-d:
@@ -84,11 +87,23 @@
 .PHONY: all-perl
 all-perl:
 	$(MAKE) checkperlbuild
-	cd C >/dev/null && $(MAKE) -e all-perl
+	cd C >/dev/null && $(MAKE) CC=$(CC) -e all-perl
 
 .PHONY: windows-gcc
 windows-gcc:
 	cd C >/dev/null && $(MAKE) -e windows-gcc
+
+.PHONY: windows-clang
+windows-clang:
+	cd C >/dev/null && $(MAKE) -e windows-clang
+
+.PHONY: windows-msys
+windows-msys:
+	cd C >/dev/null && $(MAKE) -e windows-msys
+
+.PHONY: windows-mingw
+windows-mingw:
+	cd C >/dev/null && $(MAKE) -e windows-mingw
 
 .PHONY: test
 test:
@@ -168,9 +183,7 @@
 
 .PHONY: tar
 tar:
-	@-rm -f $(MKCONFIGPATH)/*.tar.gz \
-		di-[0-9].[0-9][0-9][a-z].tar.gz > /dev/null 2>&1
-	cd $(MKCONFIGPATH) && $(MAKE) tar
+	@-rm -f di-[0-9].[0-9][0-9][a-z].tar.gz > /dev/null 2>&1
 	./mktar.sh
 
 ###
@@ -183,6 +196,7 @@
 	@-rm -rf mkconfig.cache mkc*.vars mkconfig.log \
 		checkbuild checkperlbuild checkinstall \
 		tests.done > /dev/null 2>&1
+	@-find . -name '*~' -print | xargs rm
 	@-(cd C >/dev/null && $(MAKE) clean > /dev/null 2>&1)
 	@-(cd mkconfig >/dev/null && $(MAKE) clean > /dev/null 2>&1)
 	@-(cd D >/dev/null && $(MAKE) clean > /dev/null 2>&1)
@@ -193,7 +207,7 @@
 realclean:
 	@-rm -rf mkconfig.cache mkc*.vars mkconfig.log \
 		checkbuild checkperlbuild checkinstall \
-		tests.done > /dev/null 2>&1
+		tests.done *~ */*~ */*/*~ > /dev/null 2>&1
 	@-(cd C >/dev/null && $(MAKE) realclean > /dev/null 2>&1)
 	@-(cd mkconfig >/dev/null && $(MAKE) realclean > /dev/null 2>&1)
 	@-(cd D >/dev/null && $(MAKE) realclean > /dev/null 2>&1)
@@ -204,7 +218,7 @@
 distclean:
 	@-rm -rf mkconfig.cache mkc*.vars mkconfig.log \
 		_mkconfig_runtests checkbuild checkperlbuild checkinstall \
-		tests.done _tmp_mkconfig > /dev/null 2>&1
+		tests.done _tmp_mkconfig *~ */*~ */*/*~ *.orig > /dev/null 2>&1
 	@-(cd C >/dev/null && $(MAKE) distclean > /dev/null 2>&1)
 	@-(cd mkconfig >/dev/null && $(MAKE) distclean > /dev/null 2>&1)
 	@-(cd D >/dev/null && $(MAKE) distclean > /dev/null 2>&1)
