=== debian/changelog ===
di (4.46-0.1~mx15+1) mx; urgency=medium

  * New upstream release.
  * Bump debhelper compat to 9.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 10 Jun 2018 12:36:44 -0700
