=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: di
 Section: utils
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Michael Ablassmeier <abi@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), gettext
+Build-Depends: debhelper (>= 9), gettext
 Standards-Version: 3.9.1
 Homepage: http://www.gentoo.com/di/
