## di 4.47

=== Makefile ===
--- 
+++ 
@@ -195,11 +195,10 @@
 clean:
 	@-rm -rf mkconfig.cache mkc*.vars mkconfig.log \
 		checkbuild checkperlbuild checkinstall \
-		tests.done > /dev/null 2>&1
-	@-find . -name '*~' -print | xargs rm
-	@-(cd C >/dev/null && $(MAKE) clean > /dev/null 2>&1)
-	@-(cd mkconfig >/dev/null && $(MAKE) clean > /dev/null 2>&1)
-	@-(cd D >/dev/null && $(MAKE) clean > /dev/null 2>&1)
+		tests.done > /dev/null 2>&1; exit 0
+	@-find . -name '*~' -print | xargs rm >/dev/null 2>&1; exit 0
+	@-(cd C >/dev/null && $(MAKE) clean > /dev/null 2>&1); exit 0
+	@-(cd D >/dev/null && $(MAKE) clean > /dev/null 2>&1); exit 0
 
 # Leaves:
 #  _tmp_mkconfig/, _mkconfig_runtests/
@@ -207,10 +206,9 @@
 realclean:
 	@-rm -rf mkconfig.cache mkc*.vars mkconfig.log \
 		checkbuild checkperlbuild checkinstall \
-		tests.done *~ */*~ */*/*~ > /dev/null 2>&1
-	@-(cd C >/dev/null && $(MAKE) realclean > /dev/null 2>&1)
-	@-(cd mkconfig >/dev/null && $(MAKE) realclean > /dev/null 2>&1)
-	@-(cd D >/dev/null && $(MAKE) realclean > /dev/null 2>&1)
+		tests.done *~ */*~ */*/*~ > /dev/null 2>&1; exit 0
+	@-(cd C >/dev/null && $(MAKE) realclean > /dev/null 2>&1); exit 0
+	@-(cd D >/dev/null && $(MAKE) realclean > /dev/null 2>&1); exit 0
 
 # leaves:
 #   dioptions.dat
@@ -218,10 +216,10 @@
 distclean:
 	@-rm -rf mkconfig.cache mkc*.vars mkconfig.log \
 		_mkconfig_runtests checkbuild checkperlbuild checkinstall \
-		tests.done _tmp_mkconfig *~ */*~ */*/*~ *.orig > /dev/null 2>&1
-	@-(cd C >/dev/null && $(MAKE) distclean > /dev/null 2>&1)
-	@-(cd mkconfig >/dev/null && $(MAKE) distclean > /dev/null 2>&1)
-	@-(cd D >/dev/null && $(MAKE) distclean > /dev/null 2>&1)
+		tests.done _tmp_mkconfig *~ */*~ \
+		*/*/*~ *.orig > /dev/null 2>&1; exit 0
+	@-(cd C >/dev/null && $(MAKE) distclean > /dev/null 2>&1); exit 0
+	@-(cd D >/dev/null && $(MAKE) distclean > /dev/null 2>&1); exit 0
 
 
 ###
@@ -230,6 +228,7 @@
 dioptions.dat:	features/dioptions.dat
 	@$(CP) features/dioptions.dat dioptions.dat
 	@$(CHMOD) u+w dioptions.dat
+	@touch dioptions.dat # to get mod date current
 
 ###
 # pre-checks
