=== C/Makefile ===
--- 
+++ 
@@ -37,7 +37,8 @@
 ###
 # additional flags/libraries
 #
-DI_CPPFLAGS = -DDI_LOCALE_DIR=\"$(LOCALEDIR)\"
+DI_SHARED = 
+DI_CFLAGS = -DDI_LOCALE_DIR=\\\"$(LOCALEDIR)\\\"
 
 ###
 # mkconfig variables
@@ -46,6 +47,8 @@
 MKCONFIG_TYPE = sh
 MKC_REQLIB = di.reqlibs
 MKC_TCLREQLIB = di-tcl.reqlibs
+MKC_ECHO = 
+#MKC_ECHO = -e
 
 ###
 # main
@@ -280,15 +283,15 @@
 		tests.done _tmp_mkconfig tests.d/chksh* \
 		mkconfig.cache mkc*.vars \
 		getoptn_test* gconfig.h getoptn.reqlibs \
-		mkconfig.reqlibs \
+		mkconfig.reqlibs mkc_compile.log \
 		Perl/Filesys-di-*.tar.gz \
 		Perl/Makefile.old \
-		>/dev/null 2>&1
+		>/dev/null 2>&1; exit 0
 	@-cd Perl; \
 		if [ -f Makefile ]; then \
 		$(MAKE) clean; \
 		fi
-	@-find . -name '*~' -print | xargs rm
+	@-find . -name '*~' -print | xargs rm > /dev/null 2>&1; exit 0
 
 # leaves:
 #   _mkconfig_runtests, _tmp_mkconfig, ../dioptions.dat
@@ -298,7 +301,7 @@
 	@$(MAKE) clean > /dev/null 2>&1
 	@-$(RM) -rf config.h configtcl.h gconfig.h \
 		di.env di-sh.env $(MKC_REQLIB) $(MKC_TCLREQLIB) \
-		>/dev/null 2>&1
+		>/dev/null 2>&1; exit 0
 
 # leaves:
 #   ../dioptions.dat
@@ -308,7 +311,7 @@
 	@-$(RM) -rf tests.done test_di \
 		_mkconfig_runtests _tmp_mkconfig \
 		*~ *.orig */*.orig \
-		>/dev/null 2>&1
+		>/dev/null 2>&1; exit 0
 	@-cd Perl; \
 		if [ -f Makefile ]; then \
 		$(MAKE) distclean; \
@@ -318,8 +321,9 @@
 # installation
 
 .PHONY: install
-install:	di-programs di.env
-	. ./di.env;cd ..;$(MAKE) -e prefix=$(prefix) LOCALEDIR=$(LOCALEDIR) FROMDIR=C install
+install:	di.env di-programs
+	. ./di.env;cd ..;$(MAKE) -e prefix=$(prefix) \
+		LOCALEDIR=$(LOCALEDIR) FROMDIR=C install
 
 ###
 # programs
@@ -362,12 +366,12 @@
 		$(MKC_DIR)/mkconfig.pl \
 		features/mkconfig-tcl.dat; fi
 
-$(MKC_REQLIB):	di.env config.h
-	$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
+$(MKC_REQLIB):	config.h
+	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
 		-o $(MKC_REQLIB) config.h
 
-$(MKC_TCLREQLIB):	di.env configtcl.h
-	$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
+$(MKC_TCLREQLIB):	configtcl.h
+	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
 		-o $(MKC_TCLREQLIB) configtcl.h
 
 
@@ -385,25 +389,22 @@
 TCLOBJECTS = tcldiskspace$(OBJ_EXT)
 
 di$(EXE_EXT):	$(MKC_REQLIB) $(MAINOBJECTS) $(LIBOBJECTS)
-	@echo "*** Using libs: `$(CAT) $(MKC_REQLIB)`"
-	$(CC) -o di$(EXE_EXT) \
-		$(LDFLAGS) $(MAINOBJECTS) $(LIBOBJECTS) $(LIBS) \
-		`$(CAT) $(MKC_REQLIB)`
-
-tcldiskspace.bld:	$(MKC_REQLIB) $(MKC_TCLREQLIB) $(TCLOBJECTS) \
-		$(LIBOBJECTS)
-	@echo "*** Using libs: `$(CAT) $(MKC_TCLREQLIB)` `$(CAT) $(MKC_REQLIB)`"
-	$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
-		-sharedlib -e diskspace$(SHLIB_EXT) \
-		$(TCLOBJECTS) $(LIBOBJECTS) $(LIBS) \
-		`$(CAT) $(MKC_TCLREQLIB)` `$(CAT) $(MKC_REQLIB)`
-	touch tcldiskspace.bld
+	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -link -exec $(MKC_ECHO) \
+		-r $(MKC_REQLIB) -o di$(EXE_EXT) \
+		$(MAINOBJECTS) $(LIBOBJECTS)
+	
+tcldiskspace.bld:	$(MKC_REQLIB) $(MKC_TCLREQLIB) \
+		$(TCLOBJECTS) $(LIBOBJECTS)
+	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -link -shared $(MKC_ECHO) \
+		-lib -o diskspace$(SHLIB_EXT) \
+		-r $(MKC_REQLIB) -r $(MKC_TCLREQLIB) \
+		$(TCLOBJECTS) $(LIBOBJECTS) $(LIBS)
+	@touch tcldiskspace.bld
 
 perlfilesysdi.bld:	$(MKC_REQLIB) $(LIBOBJECTS)
 	@echo "*** Using libs: `$(CAT) $(MKC_REQLIB)`"
-	$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
-		-staticlib -e libdiperl \
-		$(LIBOBJECTS) $(LIBS) \
+	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -staticlib $(MKC_ECHO) \
+		-o libdiperl.a $(LIBOBJECTS) $(LIBS) \
 		`$(CAT) $(MKC_REQLIB)`
 	# Don't know how to pass additional libs to Makefile.PL
 	# so pass all the information.
@@ -413,7 +414,7 @@
 	make ; \
 	make test ; \
 	)
-	touch perlfilesysdi.bld
+	@touch perlfilesysdi.bld
 
 mingw-di$(EXE_EXT):	$(MAINOBJECTS) $(LIBOBJECTS)
 	$(CC) -o mingw-di$(EXE_EXT) \
@@ -422,52 +423,41 @@
 ###
 # objects
 
+.c$(OBJ_EXT):
+	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -compile $(MKC_ECHO) \
+		$(DI_SHARED) $(DI_CFLAGS) $<
+
 di$(OBJ_EXT):		di.c config.h di.h dimain.h getoptn.h \
 				options.h version.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(DI_CPPFLAGS) di.c
 
 tcldiskspace$(OBJ_EXT):		tcldiskspace.c config.h di.h \
 				dimain.h getoptn.h \
 				options.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) \
-		$(DI_CPPFLAGS) tcldiskspace.c
 
 dimain$(OBJ_EXT):	dimain.c config.h di.h dimain.h getoptn.h \
 				options.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(DI_CPPFLAGS) dimain.c
 
 digetinfo$(OBJ_EXT):	digetinfo.c config.h di.h dimntopt.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) digetinfo.c
 
 didiskutil$(OBJ_EXT):	didiskutil.c config.h di.h dimntopt.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) didiskutil.c
 
 digetentries$(OBJ_EXT):	digetentries.c config.h di.h dimntopt.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) digetentries.c
 
 diquota$(OBJ_EXT):	diquota.c config.h di.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) diquota.c
 
 display$(OBJ_EXT):	display.c config.h di.h display.h options.h version.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) display.c
 
 getoptn$(OBJ_EXT):	getoptn.c config.h getoptn.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) getoptn.c
 
 options$(OBJ_EXT):	options.c config.h di.h options.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) options.c
 
 realloc$(OBJ_EXT):	realloc.c config.h di.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) realloc.c
 
 strdup$(OBJ_EXT):	strdup.c config.h di.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) strdup.c
 
 strstr$(OBJ_EXT):	strstr.c config.h di.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) strstr.c
 
 trimchar$(OBJ_EXT):	trimchar.c config.h di.h
-	$(CC) -c $(CFLAGS) $(CPPFLAGS) trimchar.c
 
 ###
 # regression testing
@@ -477,3 +467,17 @@
 
 tests.done: $(MKC_DIR)/runtests.sh
 	@echo "## running tests"
+	CC=$(CC) DC=$(DC) $(_MKCONFIG_SHELL) \
+		$(MKC_DIR)/runtests.sh ./tests.d
+	touch tests.done
+
+# needs environment
+.PHONY: testrpmbuild
+testrpmbuild:
+	-$(TEST) -d ./rpmbuild && rm -rf ./rpmbuild
+	$(MKDIR) -p ./rpmbuild/SOURCES
+	$(MKDIR) -p ./rpmbuild/BUILD
+	$(CP) -f $(DI_DIR)/di-$(DI_VERSION).tar.gz ./rpmbuild/SOURCES
+	$(RPMBUILD) --define="_topdir `pwd`/rpmbuild" -ba ../di.spec
+	$(TEST) -f ./rpmbuild/RPMS/$(MARCH)/di-$(DI_VERSION)-1.$(MARCH).rpm || exit 1
+	$(TEST) -f ./rpmbuild/SRPMS/di-$(DI_VERSION)-1.src.rpm || exit 1
