=== debian/changelog ===
di (4.47-1) unstable; urgency=medium

  * New upstream release (Closes: #770974, 734666)
  * Change Priority to optional
  * Bump standards version

 -- Michael Ablassmeier <abi@debian.org>  Mon, 25 Feb 2019 08:43:10 +0100
