=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: di
 Section: utils
-Priority: extra
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Michael Ablassmeier <abi@debian.org>
-Build-Depends: debhelper (>= 9), gettext
-Standards-Version: 3.9.1
+Priority: optional
+Maintainer: Michael Ablassmeier <abi@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), gettext
+Standards-Version: 4.3.0
 Homepage: http://www.gentoo.com/di/
 
 Package: di
